<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- ภาพรวมรายเดือน -->
    <v-container>
      <v-card>
        <v-container>
          <v-row>
            <v-col cols="12" sm="8" md="8" lg="8">
              <v-container>
                <span style="font-size: 24px">
                  ภาพรวมรายเดือน
                  <v-icon style="font-size: 24px">mdi-chevron-right</v-icon>
                  {{ select_date }}
                </span>
                <v-divider style="width: 60%"></v-divider>
              </v-container>
            </v-col>
            <v-col cols="12" sm="4" md="4" lg="4">
              <v-container class="py-0">
                <v-dialog ref="dialog" v-model="modal" :return-value.sync="date" persistent width="290px">
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="select_date"
                      label="Select year Select month"
                      append-icon="mdi-calendar"
                      @click:append="modal = true"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      outlined
                      dense
                    ></v-text-field>
                  </template>
                  <v-date-picker v-model="select_date" scrollable type="month">
                    <v-spacer></v-spacer>
                    <v-btn text color="primary" @click="modal = false">
                      Cancel
                    </v-btn>
                    <v-btn text color="primary" @click="filter_date()">
                      OK
                    </v-btn>
                  </v-date-picker>
                </v-dialog>
              </v-container>
            </v-col>
            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card outlined>
                <v-list-item>
                  <v-row>
                    <v-col cols="4" sm="4" md="4" lg="4" class="pr-1 pl-1">
                      <v-list-item-avatar tile height="75" width="75" class="mt-n7 pr-1 pl-0">
                        <v-sheet style="background: linear-gradient(60deg, #66bb6a, #43a047);" height="75" width="75" elevation="10">
                          <v-icon dark large>mdi-film</v-icon>
                        </v-sheet>
                      </v-list-item-avatar>
                    </v-col>
                    <v-col cols="8" sm="8" md="8" lg="8" class="pt-0">
                      <v-list-item-content>
                        <span class="text-right" style="font-size:18px">Balance Film</span>
                        <v-list-item-title class="headline text-right">
                          <span style="font-size:20px">
                            <span v-if="balance_film == 'unlimited'">{{ balance_film }}</span>
                            <span v-else-if="balance_film !='unlimited'">{{use_film}}</span>
                            <span v-if="balance_film != 'unlimited'">/ {{ limit_film }}</span>
                          </span>
                        </v-list-item-title>
                        <div><v-divider></v-divider></div>
                      </v-list-item-content>
                    </v-col>
                  </v-row>
                </v-list-item>
                <v-card-actions>
                  <v-icon text class="ma-2">mdi-person</v-icon>
                  <span style="font-size: 13.5px">
                    * จำนวนฟิล์มที่เหลือ {{ balance_film }}
                    <span v-if="balance_film != 'unlimited'">
                      จาก {{ limit_film }}</span>
                  </span>
                </v-card-actions>
              </v-card>
            </v-col>
            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card outlined>
                <v-list-item>
                  <v-row>
                    <v-col cols="4" sm="4" md="4" lg="4" class="pr-1 pl-1">
                      <v-list-item-avatar tile height="70" width="70" class="mt-n7 pr-1 pl-0">
                        <v-sheet style="background: linear-gradient(60deg, #26c6da, #00acc1);" height="70" width="70" elevation="10">
                          <v-icon dark large>mdi-cloud-check</v-icon>
                        </v-sheet>
                      </v-list-item-avatar>
                    </v-col>
                    <v-col cols="8" sm="8" md="8" lg="8" class="pt-0">
                      <v-list-item-content>
                        <span class="text-right" style="font-size:18px">Used Film</span>
                        <v-list-item-title class="headline text-right">
                          <span style="font-size:20px">{{ use_film }}</span>
                        </v-list-item-title>
                        <div><v-divider></v-divider></div>
                      </v-list-item-content>
                    </v-col>
                  </v-row>
                </v-list-item>
                <v-card-actions>
                  <v-icon text class="ma-2">mdi-subscriptions</v-icon>
                  <span style="font-size: 13.5px">* จำนวนฟิล์มที่ใช้ไปทั้งหมด {{ use_film }} </span>
                </v-card-actions>
              </v-card>
            </v-col>
            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card outlined>
                <v-list-item>
                  <v-row>
                    <v-col cols="4" sm="4" md="4" lg="4" class="pr-1 pl-1">
                      <v-list-item-avatar tile height="70" width="70" class="mt-n7 pr-1 pl-0">
                        <v-sheet style="background: linear-gradient(60deg, #ffa726, #fb8c00);" height="70" width="70" elevation="10">
                          <v-icon dark large>mdi-finance</v-icon>
                        </v-sheet>
                      </v-list-item-avatar>
                    </v-col>
                    <v-col cols="8" sm="8" md="8" lg="8" class="pt-0">
                      <v-list-item-content>
                        <span class="text-right" style="font-size:18px">Over Film</span>
                        <v-list-item-title class="headline text-right">
                          <span style="font-size:20px">{{ over_film }}</span>
                        </v-list-item-title>
                        <div><v-divider></v-divider></div>
                      </v-list-item-content>
                    </v-col>
                  </v-row>
                </v-list-item>
                <v-card-actions>
                  <v-icon text class="ma-2"></v-icon>
                  <span style="font-size: 13.5px">* จำนวนฟิล์มที่ใช้เกินทั้งหมด {{ over_film_default }} </span>
                </v-card-actions>
              </v-card>
            </v-col>
            <v-col cols="12" sm="6" md="6" lg="3">
              <v-card outlined>
                <v-list-item>
                  <v-row>
                    <v-col cols="4" sm="4" md="4" lg="4" class="pr-1 pl-1">
                      <v-list-item-avatar
                        tile height="70" width="70" class="mt-n7 pr-1 pl-0">
                        <v-sheet color="red" height="70" width="70" elevation="10">
                          <v-icon dark large>mdi-alert-circle-outline</v-icon>
                        </v-sheet>
                      </v-list-item-avatar>
                    </v-col>
                    <v-col cols="8" sm="8" md="8" lg="8" class="pt-0">
                      <v-list-item-content>
                        <span class="text-right" style="font-size:18px">Fail Film</span>
                        <v-list-item-title class="headline text-right">
                          <span style="font-size:20px">{{ fail_film }}</span>
                        </v-list-item-title>
                        <div><v-divider></v-divider></div>
                      </v-list-item-content>
                    </v-col>
                  </v-row>
                </v-list-item>
                <v-card-actions>
                  <span style="font-size: 13.5px">* จำนวนฟิล์มล้มเหลวทั้งหมด {{ fail_film }}</span>
                </v-card-actions>
              </v-card>
            </v-col>
            <v-col cols="12" sm="8" md="8" lg="8">
              <v-container class="py-2">
                <span style="font-size: 24px" class="ml-4">
                  ตารางตรวจสอบสถานะการอัพโหลด
                </span>
                <v-divider class="ml-4" style="width: 60%"></v-divider>
              </v-container>
            </v-col>
            <v-col cols="12" sm="4" md="4" lg="4">
              <v-container class="py-0">
                <v-text-field
                  outlined
                  dense
                  v-model="search"
                  append-icon="mdi-magnify"
                  label="Search username / status"
                ></v-text-field>
              </v-container>
            </v-col>
          </v-row>
          <div>
            <v-data-table :headers="headers" :items="all_dashboard" :search="search" :items-per-page="5" class="elevation-0 ma-3">
              <template v-slot:item.status_wait="{ item }">
                <span v-if="item.status_wait == 'success'" style="color: teal">Success</span>
                <span v-else style="color: red">Fail </span>
              </template>
            </v-data-table>
          </div>
        </v-container>
      </v-card>
    </v-container>
    <!-- ภาพรวมรายเดือน -->
  </v-app>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      api: process.env.VUE_APP_API,
      moment,
      search: "",
      dialog_loader: false,
      balance_film: 0,
      limit_film: 0,
      use_film: 0,
      fail_film: 0,
      over_film: 0,
      over_film_default: 0,
      select_date: new Date().toISOString().substr(0, 10),
      date: new Date().toISOString().substr(0, 10),
      menu: false,
      modal: false,
      headers: [
        {
          text: "Username",
          align: "start",
          value: "username",
          sortable: false
        },
        {
          text: "Filename",
          align: "start",
          value: "old_filename",
          sortable: false
        },
        {
          text: "Action",
          align: "start",
          value: "action",
          sortable: false
        },
        {
          text: "Timestamp",
          align: "start",
          value: "upload_datetime",
          sortable: false
        },
        {
          text: "Status",
          align: "start",
          value: "status_wait",
          sortable: false
        }
      ],
      all_dashboard: []
    };
  },
  mounted() {
    this.select_date = moment(this.select_date).format("YYYY-MM");
    this.get_month_dashboard();
    console.log("api:", this.api)
  },
  methods: {
    get_month_dashboard() {
      this.dialog_loader = true;
      this.axios
        .get(
          process.env.VUE_APP_API + "/api/v3/film_overview/Month_filmoverview",
          {
            params: {
              hospital_id: this.$cookies.get("info_login").hospital_id,
              user_id: this.$cookies.get("info_login").user_id,
              date_time: this.select_date + "-01"
            },
            headers: {
              Authorization: this.$cookies.get("info_login").session_id
            }
          }
        )
        .then(response => {
          console.log("response", response);
          this.balance_film = response.data.data.balance_film;
          this.limit_film = response.data.data.limit_film;
          this.use_film = response.data.data.use_film;
          this.over_film = response.data.data.overfilm;
          this.over_film_default = response.data.data.overfilm;
          var file_fail = response.data.data.file_fail;
          var file_wait = response.data.data.file_wait;
          this.fail_film = file_fail + file_wait;
          this.all_dashboard = response.data.data.dashborad;
          // check status wait //
          for (let index = 0; index < response.data.data.dashborad.length; index++) {
            if (response.data.data.dashborad[index].status_wait == "wait") {
              console.log(response.data.data.dashborad[index].status_wait);
              response.data.data.dashborad[index].status_wait = "Fail";
              this.all_dashboard[index].status_wait == response.data.data.dashborad[index].status_wait;
            }
          }
          console.log("all_dashboard", this.all_dashboard);
          if (this.fail_film > 0) {
            if (this.over_film == 0) {
              this.balance_film = this.balance_film + this.fail_film;
            }
            else if (this.over_film > this.fail_film) {
              this.over_film = this.over_film - this.fail_film;
            }
            else if (this.over_film < this.fail_film) {
              let count = 0;
              console.log("balance", this.balance_film);
              count = this.fail_film - this.over_film;
              this.balance_film = this.balance_film + count;
            }
          }
          else if (this.overfilm == 0) {
            this.balance_film = this.balance_film + this.fail_film;
          }
          this.dialog_loader = false;
        })
        .catch(error => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
        });
    },
    filter_date() {
      this.modal = false;
      this.get_month_dashboard();
    },

    reset_datetime() {
      var time_now = new Date().toISOString().substr(0, 10);
      this.select_date = moment(time_now).format("YYYY-MM");
      console.log("reset", this.select_date);
      this.get_month_dashboard();
    }
  }
};
</script>

<style scoped>
>>> .v-input__control > .v-input__slot {
  cursor: pointer;
}
</style>
